#include <stdlib.h>
#include <stdio.h>
#include <getopt.h>
#include <unistd.h>

char *path = "/usr/local/etc/citat.txt";
const char *version = "1.0";
int cols = 80;

int parametry(int _argc,char **_argv);
int nl(FILE *which);
void usage(void);
void print_version(void);
int discardln(FILE *which);
char *freadln(FILE *which);
void writef(char *str);
void rand_init(void);

int main(int argc,char **argv)
{
 unsigned cislo,number_of_lines,i;
 char *quote;
 FILE *soubor;

 parametry(argc,argv); /* zpracujeme parametry */
 rand_init();
 soubor = fopen(path,"r");
 if(!soubor)
  {
   return(printf("Nemohu otevrit soubor %s\n",path)?1:1);
  }
 number_of_lines =  nl(soubor);
 cislo = (int) ((double)(number_of_lines)*rand()/(RAND_MAX+1.0));
 i = 0;
 while(i!=cislo)
  {
   discardln(soubor);
   i++;
  }
 quote = freadln(soubor);
 if(!quote)
  {
   printf("Nemohu alokovat dostatek pameti!\n");
   return 1;
  }
 writef(quote);
 free(quote);
 return 0;
}

int parametry(int _argc,char **_argv)
{
 static struct option options[] =
 {
  {"help",0,NULL,'h'},
  {"version",0,NULL,'v'},
  {"file",1,NULL,'f'},
  {"cols",1,NULL,'c'},
  {NULL,0,NULL,0}
 };
 int option_index = 0,c;
 c = getopt_long (_argc,_argv,"hvf:c:",options,&option_index);
 while(c != EOF)
  {
   switch(c)
   {
    case 'h': usage(); exit(0);
    case 'v': print_version(); exit(0);
    case 'f': path = optarg; break;
    case 'c': cols = atoi(optarg);
              if(cols<20) 
               {
                printf("Hodnota je prilis mala!\n");
                usage();
                exit(1);
               };
              break;
    default: usage(); exit(1);
   }
   c = getopt_long (_argc,_argv,"hvf:c:",options,&option_index);
  }
 return 0;
}

int nl(FILE *which)
{
 int i = 0;
 while(!feof(which))
  {
   (void)discardln(which);
   i++;
  }
 i--;
 if(fseek(which, 0L, SEEK_SET))
 {
  printf("Chyba pri vyhledavani zacatku souboru!\n");
  exit(1);
  /* mozna nam nekdo zrovna odebral pravo na cteni */
 }
 return i;
}

void usage(void)
{
 printf("Pouziti: citat [volba]\nvolby:");
 printf("\t-h,--help                       : napis tuto zpravu a skonci\n");
 printf("\t-v,--version                    : napis verzi programu a skonci\n");
 printf("\t-f FILE,--file FILE,--file=FILE : pouzij soubor FILE\n");
 printf("\t-c COLS,--cols COLS,--cols=COLS : terminal ma COLS sloupcu\n");
 printf("Vice v man-ove strance\n");
}

int discardln(FILE *which)
{
 char radka[100];
 int j;
 fgets(radka,100,which);
 while(1)
  {
   for(j=0;j<100&&radka[j]!='\n';j++);
   if(j!=100 || feof(which)) break;
   fgets(radka,100,which);
  }
 return 0;
}

char *freadln(FILE *which)
{
 char *buf;
 int i=1,ch;
 ch = fgetc(which);
 while(ch!='\n' && ch!=EOF)
 {
  ch = fgetc(which);
  i++;
 }
 if(ch==EOF) i--;
 fseek(which,-i,SEEK_CUR);
 buf = (char *)malloc(++i);
 if(buf == NULL) return 0;
 fgets(buf,i,which);
 return buf;
}

void writef(char *str)
{
 int i=0,pos=0,length=0,j;
 printf("\033[1m");
 for(;str[i]&&str[i]!=':';i++,pos++) putchar(str[i]);
 printf ("\033[m");
 for(;str[i];i++)
  {
   if(!isspace(str[i])) length++;
   else
    if(length)
    {
     pos += length;
     if(pos<cols)
     { 
      for(j=i-length;j<i;j++) putchar(str[j]);
      pos++;
     }
     else
     {
      putchar('\n');
      for(j=i-length;j<i;j++) putchar(str[j]);
      pos = length;
     } 
     length = 0;
     putchar(' ');
    }
  }
 putchar('\n');
}

void print_version(void)
{
 printf("Citat, verze %s\n\
Vytvoril Winston - literakl@risc.upol.cz\n",version); 
}

void rand_init(void)
{
 int i = getpid();
 int j = (int)(time(0)&0xffff);
 /* nastavime nahodne seminko generatoru */
 srand(i+j); 
 for(i &= 7;i >= 0;i--) rand();
 /* nektere citaty by jinak nebyly nikdy precteny */
}
